<template>
  <v-main class="main-style">
    <v-card class="bg-blue-darken-4 mb-3">
      <h2 class="m-3">Mitarbeiter</h2>
    </v-card>

    <v-row>
      <v-col cols="12" sm="6">
        <v-text-field
            v-model="search"
            label="Suchen"
            append-icon="mdi-magnify"
            single-line
            hide-details
        ></v-text-field>
      </v-col>
    </v-row>
    <v-card>
      <table class="table table-hover table-bordered text-center">
        <thead>
        <tr>
          <th>ID</th>
          <th>Username</th>
          <th>E-Mail</th>
          <th>Vorname</th>
          <th>Nachname</th>
          <th>Geburtsdatum</th>
          <th>Abteilung</th>
          <th>Rolle</th>
          <th>Aktionen</th>
        </tr>
        </thead>
        <tbody>
        <employee-data
            v-for="user in filteredUsers"
            :user="user"
            :page="currentPage"
        ></employee-data>
        </tbody>
        <tr>
          <td colspan="2">
            <v-btn
                color="blue-darken-4"
                @click="prevPage"
                :disabled="currentPage === 1"><v-icon>mdi-arrow-left-drop-circle-outline</v-icon></v-btn>
          </td>
          <td colspan="5">
            <p class="border-light-subtle mt-2 text-center">Seite: {{currentPage}}</p>
          </td>
          <td colspan="2">
            <v-btn
                color="blue-darken-4"
                :disabled="userStore.users.length < 10"
                @click="nextPage"><v-icon>mdi-arrow-right-drop-circle-outline</v-icon></v-btn>
          </td>
        </tr>
      </table>
    </v-card>


  </v-main>

</template>

<script setup>

import {useUserStore} from "@/stores/userStore";
import {computed, onMounted, ref} from "vue";
import EmployeeData from "@/components/EmployeeData.vue";
import {useAuthStore} from "@/stores/authStore";
import {useDepartmentStore} from "@/stores/departmentStore";

//STORES
const userStore = useUserStore();
const authStore = useAuthStore();

//VARIABLES
const currentPage = ref(1);
const search = ref("");

// Filter users
const filteredUsers = computed(() => {
  if(search.value) {
    return userStore.users.filter(user =>
        user.username.toLowerCase().includes(search.value.toLowerCase()) ||
        user.firstName.toLowerCase().includes(search.value.toLowerCase()) ||
        user.lastName.toLowerCase().includes(search.value.toLowerCase()) ||
        user.department.toLowerCase().includes(search.value.toLowerCase()) ||
        user.role.toLowerCase().includes(search.value.toLowerCase())
    );
  } else {
    return userStore.users;
  }
});

async function fetchUsers(page) {
  await userStore.getUsers(page);
}

function nextPage() {
  currentPage.value++;
  fetchUsers(currentPage.value);
}

function prevPage() {
  if (currentPage.value > 0) {
    currentPage.value--;
    fetchUsers(currentPage.value);
  }
}

onMounted(async () => {
  await fetchUsers(currentPage.value);
})
</script>

<style scoped>

.main-style {
  min-height: 95vh;
}

</style>